@ECHO OFF
goto  :TopOfCode

This routine adds EXIF an IPTC information to JPGs and other image files by creating a command file that can be used by the EXIFTOOL program. The input information
comes from a CSV file that is exported from MS-EXCEL.

No special usage parameters are provided 

Input: 
  Format of CSV File:
    The input file should be a CSV file exported from MS-EXCEL using the 'save as' command with a 'Save as type' of 'CSV (Comman delimited)(*.csv)'.
    named as appropriate. 
    Note: lines that have a semi-colon (;) at the start are ignored (default action of the 'FOR /F' command)

  Columns are:
          Column 1 (A) : identifier for image - i.e the name of the file that is going to have EXIF/IPTC information added to it.
          Column 2 (B): date picture taken (optional)
          Column 3 (C): description of image
          Column 4 (D): location of image
          Column 5 (E): author of image
          Column 6 (F): tags (separated by semi-colons)

Output: 
  Command file that can be used by the EXIFTOOL program. EXIFTOOL call syntax is 'EXIFTOOL -@ ExifToolCommandList.txt'

:TopOfCode
setlocal enableDelayedExpansion
SET _Inputfile=$NameOfPhotoListingIndexFile.csv
del ExifToolCommandList.txt

rem Get the file - first column is variable A, next is B etc. and build up the command file

echo Starting to build EXIFTOOL command file

rem The extra read is so that I can turn nulls ',,'  into ', space  ,' so that they are read correctly

for /f "delims=" %%L in (%_InputFile%) do (
  set line=%%L
  set line=!line:,,=, ,!
  set line=!line:,,=, ,!
  set line=!line:,,=, ,!
  set line=!line:,,=, ,!
  set line=!line:,,=, ,!
  for /f "tokens=1-6 delims=," %%A in (^"!line!^") do (
    echo .\%%~A.jpg 
    echo -XMP-acdsee:Caption=%%B %%D %%C ^(%%~A^)
    echo -UserComment=%%B %%D %%C - National Railway Museum, Port Adelaide, Collection - Miscellaneous Negatives Collection ^(CRS 7-1074^)
    echo -MWG:Creator=%%E - National Railway Museum, Port Adelaide 
    echo -MWG:Copyright= 
    echo -MWG:Description=%%B %%D %%C ^(%%~A^)
    echo -MWG:City=%%D
    echo -XMP:Credit=Scanned by Chris Drymalik
    echo -XMP:Subject=%%F
    echo -execute
  )
)>> ExifToolCommandList.txt


rem echo========SOF
rem TYPE ExifToolCommandList.txt
rem echo========EOF

echo Command file built - check output then press ENTER to proceed with adding information to picture
pause

EXIFTOOL -@ ExifToolCommandList.txt

echo EXIFTOOL processing comp[lete - press ENTER to finish

pause

:End